<?php
namespace Magento\Search\Model\ResourceModel\Query;

/**
 * Interceptor class for @see \Magento\Search\Model\ResourceModel\Query
 */
class Interceptor extends \Magento\Search\Model\ResourceModel\Query implements \Magento\Framework\Interception\InterceptorInterface
{
    use \Magento\Framework\Interception\Interceptor;

    public function __construct(\Magento\Framework\Model\ResourceModel\Db\Context $context, \Magento\Framework\Stdlib\DateTime\DateTime $date, \Magento\Framework\Stdlib\DateTime $dateTime, $connectionName = null)
    {
        $this->___init();
        parent::__construct($context, $date, $dateTime, $connectionName);
    }

    /**
     * {@inheritdoc}
     */
    public function load(\Magento\Framework\Model\AbstractModel $object, $value, $field = null)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'load');
        return $pluginInfo ? $this->___callPlugins('load', func_get_args(), $pluginInfo) : parent::load($object, $value, $field);
    }

    /**
     * {@inheritdoc}
     */
    public function saveIncrementalPopularity(\Magento\Search\Model\Query $query)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'saveIncrementalPopularity');
        return $pluginInfo ? $this->___callPlugins('saveIncrementalPopularity', func_get_args(), $pluginInfo) : parent::saveIncrementalPopularity($query);
    }

    /**
     * {@inheritdoc}
     */
    public function saveNumResults(\Magento\Search\Model\Query $query)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'saveNumResults');
        return $pluginInfo ? $this->___callPlugins('saveNumResults', func_get_args(), $pluginInfo) : parent::saveNumResults($query);
    }

    /**
     * {@inheritdoc}
     */
    public function save(\Magento\Framework\Model\AbstractModel $object)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'save');
        return $pluginInfo ? $this->___callPlugins('save', func_get_args(), $pluginInfo) : parent::save($object);
    }

    /**
     * {@inheritdoc}
     */
    public function delete(\Magento\Framework\Model\AbstractModel $object)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'delete');
        return $pluginInfo ? $this->___callPlugins('delete', func_get_args(), $pluginInfo) : parent::delete($object);
    }
}
